'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var decorators = require('@react-efficiency/decorators');
var lodashEs = require('lodash-es');
var React = require('react');
var axios = _interopDefault(require('axios'));
var immutable = require('immutable');
var cursor = require('immutable/contrib/cursor');
var uuid = require('uuid');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

/**
 * 页面的组件
 */
function buildPageComponent(p) {
    return function build(Target) {
        var Build = /** @class */ (function (_super) {
            __extends(Build, _super);
            function Build(props) {
                var _this = _super.call(this, props) || this;
                _this.handler = p.buildHandler
                    ? p.buildHandler(_this.props)
                    : {};
                /**
                 * 获得最新的基本信息
                 */
                _this.getInfo = function () {
                    var dispatch = _this.props.dispatch;
                    // 原始的数据
                    var serverData = [];
                    // 是否有接口请求中
                    var requesting = false;
                    // 是否有接口发生错误
                    var error = false;
                    // 所有数据是否加载完毕
                    var allDataLoad = true;
                    p.serverActions.map(function (serverAction) {
                        var serverDataItme = dispatch(serverAction.getResponseData());
                        serverData.push(serverDataItme);
                        // 只要有一个加载中，则表示数据在加载中
                        if (dispatch(serverAction.isRequesting())) {
                            requesting = true;
                        }
                        // 表示数据有错误
                        if (dispatch(serverAction.isError())) {
                            error = true;
                        }
                        // 如果有有的数据为null则表示数据为没有加载完毕
                        if (dispatch(serverAction.getResponseData()) === undefined) {
                            allDataLoad = false;
                        }
                    });
                    return {
                        serverData: serverData,
                        requesting: requesting,
                        error: error,
                        allDataLoad: allDataLoad,
                    };
                };
                /**
                 * 计算组件的props
                 */
                _this.addProps = function () {
                    var info = _this.getInfo();
                    var newProps = p.mapStateToProps(_this.props.state, __assign({}, _this.props, info, { dataChangeNumber: _this.state.dataChangeNumber, getInfo: function () { return _this.getInfo(); } }));
                    return __assign({}, newProps, { serverData: info.serverData, requesting: info.requesting, error: info.error, allDataLoad: info.allDataLoad });
                };
                _this.state = {
                    dataChangeNumber: 0,
                    hashs: [],
                    requesting: _this.getInfo().requesting,
                };
                return _this;
            }
            /**
             * getSnapshotBeforeUpdate
             */
            Build.prototype.getSnapshotBeforeUpdate = function () {
                var nextProps = this.props;
                var state = this.state;
                var info = this.getInfo();
                var hashs = [];
                p.serverActions.map(function (action) {
                    hashs.push(nextProps.dispatch(action.getServer()).get('hash'));
                });
                if (info.allDataLoad && !lodashEs.isEqual(hashs, state.hashs)) {
                    if (p.serverRely) {
                        if (isAllNotSame(hashs, state.hashs)) {
                            state.dataChangeNumber = state.dataChangeNumber + 1;
                            state.hashs = hashs;
                        }
                    }
                    else {
                        state.dataChangeNumber = state.dataChangeNumber + 1;
                        state.hashs = hashs;
                    }
                }
                return null;
            };
            Build.prototype.render = function () {
                var newProps = this.addProps();
                return React.createElement(Target, __assign({}, this.props, newProps, this.handler));
            };
            Build.displayName = Target.displayName;
            Build = __decorate([
                decorators.addDispatchToProps
            ], Build);
            return Build;
        }(React.Component));
        return Build;
    };
}
/**
 * 是否全部相同
 */
function isAllNotSame(list1, list2) {
    for (var i = 0; i < list1.length; i++) {
        var item1 = list1[i];
        var item2 = list2[i];
        if (item1 === item2) {
            return false;
        }
    }
    return true;
}

/**
 * 页面的主体
 */
function buildPage(pa) {
    return function _buildPage(Target) {
        var Page = /** @class */ (function (_super) {
            __extends(Page, _super);
            function Page() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.state = {
                    load: false,
                };
                return _this;
            }
            Page.prototype.componentDidMount = function () {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!pa.setData) return [3 /*break*/, 2];
                                return [4 /*yield*/, pa.setData(this.props)];
                            case 1:
                                _a.sent();
                                _a.label = 2;
                            case 2:
                                this.setState({ load: true });
                                return [2 /*return*/];
                        }
                    });
                });
            };
            Page.prototype.componentWillUnmount = function () {
                this.props.dispatch(pa.pageActions.leavePage(Target.displayName));
            };
            Page.prototype.render = function () {
                if (!this.state.load) {
                    return React.createElement("span", null);
                }
                return React.createElement(Target, __assign({}, this.props));
            };
            Page.displayName = Target.displayName;
            Page = __decorate([
                decorators.addDispatchToProps
            ], Page);
            return Page;
        }(React.Component));
        return Page;
    };
}

/**
 * 生产wigets函数的type
 * @param {string} type
 * @param {string[]} hashList
 */
function buildWidgetType(type) {
    var hashList = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        hashList[_i - 1] = arguments[_i];
    }
    hashList.map(function (hash, index) {
        if (index === 0) {
            type = '@@_' + type + '_._' + hash;
        }
        else {
            type = type + '_.' + hash;
        }
    });
    return type;
}
/**
 * 统一规划，生成meta
 * @param {string} where 来自哪里
 * @param {string} use 做什么用的
 */
function buildMeta(where, use) {
    if (where === void 0) { where = ''; }
    return "from\uFF1A" + where + " -> effect\uFF1A" + use;
}
/**
 * 把带有_keyPath的immutable数据去掉_keyPath
 * @param data 带有_keyPath的immutable数据
 */
function toMap(data) {
    if (data === null && data === undefined) {
        return data;
    }
    if (data.hasOwnProperty('_keyPath')) {
        return data._rootData.getIn(data._keyPath);
    }
    return data;
}

/**
 * 页面的widgets
 * @param config
 */
var buildPageWidgets = function (config) {
    var _hash = '_BASE_PAGE_';
    var keyPath = lodashEs.isArray(config.reducerKey)
        ? config.reducerKey
        : [config.reducerKey];
    var defaultData = config.defaultData;
    var types = buildTypes(_hash, config);
    var reducerMap = buildReducerMap(types, defaultData);
    var actions = buildPageActions(types, keyPath);
    var createServerActions = buildServer(config, actions, types);
    return {
        actions: actions,
        reducerMap: reducerMap,
        createServerActions: createServerActions,
    };
};
function buildServer(config, actions, types) {
    var _this = this;
    return function (rootConfig) {
        var pageAxiosOpt = lodashEs.defaultTo(config.axiosOpt, {});
        var axiosOpt = __assign({}, pageAxiosOpt, rootConfig.axiosOpt);
        var key = rootConfig.key;
        var meta = rootConfig.desc;
        var serverActions = {
            getResponseData: function (isCursor) {
                if (isCursor === void 0) { isCursor = true; }
                return function (dispatch) {
                    return dispatch(actions.getRootState(isCursor)).getIn([
                        'server',
                        key,
                        'responseData',
                    ]);
                };
            },
            getServer: function (isCursor) {
                if (isCursor === void 0) { isCursor = true; }
                return function (dispatch) {
                    return dispatch(actions.getRootState(isCursor)).getIn(['server', key]);
                };
            },
            setRequesting: function (ap) {
                return {
                    type: types.SET_AJAXING,
                    payload: {
                        key: key,
                        value: ap.value,
                        axiosSource: ap.axiosSource,
                        axios: ap.axios,
                    },
                    meta: buildMeta(ap.meta, '设置请求中'),
                };
            },
            setData: function (responseData) {
                return {
                    type: types.SET_DATA,
                    payload: {
                        key: key,
                        responseData: responseData,
                    },
                    meta: buildMeta(meta, '把数据保存到store'),
                };
            },
            isRequesting: function () { return function (dispatch) {
                return dispatch(actions.getRootState()).getIn([
                    'server',
                    key,
                    'requesting',
                ]);
            }; },
            isError: function () { return function (dispatch) {
                return dispatch(actions.getRootState()).getIn(['server', key, 'error']);
            }; },
            startRequest: function (ap) { return function (dispatch) { return __awaiter(_this, void 0, void 0, function () {
                var CancelToken, source, requesting, num, $$serverData, oneAxios, response;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            axiosOpt = __assign({}, axiosOpt, ap.axiosOpt);
                            CancelToken = axios.CancelToken;
                            source = CancelToken.source();
                            requesting = dispatch(serverActions.isRequesting());
                            num = dispatch(serverActions.getServer()).get('number');
                            if (rootConfig.isInitData) {
                                // 中断请求之后的代码
                                if (requesting && num !== 0) {
                                    throw {
                                        msg: '重复请求！',
                                        params: ap,
                                        requesting: requesting,
                                        number: num,
                                    };
                                }
                            }
                            if (!rootConfig.isInitData && requesting) {
                                throw {
                                    msg: '重复请求！',
                                    params: ap,
                                    requesting: requesting,
                                    number: num,
                                };
                            }
                            $$serverData = dispatch(serverActions.getResponseData());
                            if (!(process.env.NODE_ENV !== 'production' &&
                                $$serverData != null &&
                                !ap.force)) return [3 /*break*/, 1];
                            return [2 /*return*/, { data: $$serverData.toJS() }];
                        case 1:
                            if (!(ap.delay !== undefined)) return [3 /*break*/, 3];
                            return [4 /*yield*/, sleep(ap.delay)];
                        case 2:
                            _a.sent();
                            _a.label = 3;
                        case 3:
                            oneAxios = axios(__assign({}, axiosOpt, { cancelToken: source.token })).catch(function (thrown) {
                                dispatch(serverActions.setRequesting({
                                    value: false,
                                    meta: meta,
                                }));
                                dispatch(serverActions.setError(immutable.fromJS(thrown.response.data)));
                                // 取消请求
                                if (axios.isCancel(thrown)) {
                                    // 取消回调
                                    ap.onCancle && ap.onCancle();
                                    // 终端请求之后的代码
                                    throw { msg: '取消请求！', params: ap };
                                }
                                // 其他类似500，404错误处理
                                throw {
                                    msg: "request error \uFF01" + thrown.config.method + " url\uFF1A" + thrown.config.url + "\uFF0Cstatus\uFF1A" + thrown.response.status,
                                    thrown: thrown,
                                };
                            });
                            // 打开请求中
                            dispatch(serverActions.setRequesting({
                                meta: meta,
                                value: true,
                                axios: oneAxios,
                                axiosSource: source,
                            }));
                            return [4 /*yield*/, oneAxios
                                // 关闭请求中
                            ];
                        case 4:
                            response = _a.sent();
                            // 关闭请求中
                            dispatch(serverActions.setRequesting({
                                meta: meta,
                                value: false,
                            }));
                            return [2 /*return*/, response];
                    }
                });
            }); }; },
            requestAndSave: function (ap) {
                if (ap === void 0) { ap = { axiosOpt: {} }; }
                return function (dispatch) { return __awaiter(_this, void 0, void 0, function () {
                    var response;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                axiosOpt = __assign({}, axiosOpt, ap.axiosOpt);
                                return [4 /*yield*/, dispatch(serverActions.startRequest({
                                        axiosOpt: axiosOpt,
                                        force: lodashEs.defaultTo(ap.force, rootConfig.force),
                                    }))];
                            case 1:
                                response = _a.sent();
                                rootConfig.done && rootConfig.done(response, serverActions, dispatch);
                                dispatch(serverActions.setData(immutable.fromJS(response.data)));
                                return [2 /*return*/, response];
                        }
                    });
                }); };
            },
            cancelRequest: function (msg) {
                if (msg === void 0) { msg = rootConfig.desc; }
                return function (dispatch) {
                    var axiosSource = dispatch(serverActions.getServer()).get('axiosSource');
                    if (axiosSource) {
                        axiosSource.cancel(msg);
                    }
                };
            },
            setError: function (responseData) {
                return {
                    type: types.SET_ERROR,
                    payload: {
                        key: key,
                        responseData: responseData,
                    },
                    mete: buildMeta(meta, '设置错误'),
                };
            },
        };
        return serverActions;
    };
}
function buildTypes(_hash, config) {
    return {
        SET_DATA: buildWidgetType('SET_DATA', _hash, config.hash),
        SET_AJAXING: buildWidgetType('SET_AJAXING', _hash, config.hash),
        LEVEL_PAGE: buildWidgetType('LEVEL_PAGE', _hash, config.hash),
        SET_ERROR: buildWidgetType('SET_ERROR', _hash, config.hash),
        SIMPLE: buildWidgetType('SIMPLE', _hash, config.hash),
        SIMPLE_CB: buildWidgetType('SIMPLE_CB', _hash, config.hash),
    };
}
function buildPageActions(types, keyPath) {
    var actions = {
        leavePage: function (meta) { return function (dispatch) {
            var $$servers = dispatch(actions.getRootState()).getIn(['server']);
            // 取消所有的请求
            $$servers &&
                $$servers.map(function ($$item) {
                    if ($$item.get('axiosSource')) {
                        return $$item.get('axiosSource').cancel(function (r) { return r(); });
                    }
                });
            dispatch({
                type: types.LEVEL_PAGE,
                meta: buildMeta(meta, '离开页面'),
            });
        }; },
        getRootState: function (isCursor) { return function (dispatch, getState) {
            var state = getState();
            // 如果根部状态树是使用redux-immutable生成的immutable类型
            if (immutable.Iterable.isIterable(state)) {
                return isCursor ? cursor.from(state.getIn(keyPath)) : state.getIn(keyPath);
            }
            else {
                return isCursor ? cursor.from(state[keyPath[0]]) : state[keyPath[0]];
            }
        }; },
        simple: function (ap) {
            return {
                type: types.SIMPLE,
                payload: ap.state,
                meta: buildMeta(ap.meta, '简单改变'),
            };
        },
        simpleCb: function (cb, meta) {
            return {
                type: types.SIMPLE_CB,
                payload: cb,
                meta: buildMeta(meta, '简单改变'),
            };
        },
    };
    return actions;
}
function buildReducerMap(types, defaultData) {
    var _a;
    return _a = {},
        _a[types.SET_AJAXING] = function (state, action) {
            var payload = action.payload;
            return state.updateIn(['server', payload.key], function ($$item) {
                return $$item
                    .set('requesting', payload.value)
                    .set('axios', payload.axios)
                    .set('axiosSource', payload.axiosSource)
                    .update('number', function (v) { return (!payload.value ? v + 1 : v); });
            });
        },
        _a[types.SET_DATA] = function (state, action) {
            var payload = action.payload;
            return state.updateIn(['server', payload.key], function ($$v) {
                return $$v
                    .set('responseData', payload.responseData)
                    .set('hash', uuid.v4())
                    .set('error', false);
            });
        },
        _a[types.SET_ERROR] = function (state, action) {
            var payload = action.payload;
            return state.updateIn(['server', payload.key], function ($$v) {
                return $$v
                    .set('hash', uuid.v4())
                    .set('error', true)
                    .set('responseData', payload.responseData);
            });
        },
        _a[types.LEVEL_PAGE] = function (state) {
            return process.env.NODE_ENV !== 'production' ? state : defaultData;
        },
        _a[types.SIMPLE] = function (state, _a) {
            var payload = _a.payload;
            return payload;
        },
        _a[types.SIMPLE_CB] = function (state, _a) {
            var payload = _a.payload;
            return payload(state);
        },
        _a;
}
/**
 * 生成server[key]的默认数据
 */
function initServerData(p) {
    if (p === void 0) { p = { requesting: false }; }
    return {
        responseData: undefined,
        hash: undefined,
        number: 0,
        requesting: p.requesting,
        error: false,
    };
}
function sleep(time) {
    if (time === void 0) { time = 0; }
    return new Promise(function (r) {
        setTimeout(function () {
            r();
        }, time);
    });
}

exports.buildMeta = buildMeta;
exports.buildPageComponent = buildPageComponent;
exports.buildPageMain = buildPage;
exports.buildPageWidgets = buildPageWidgets;
exports.initServerData = initServerData;
exports.toMap = toMap;
